﻿param(
    [Parameter(mandatory = $true)][string]$SolutionFolder
)

$ConfirmPreference = "none"
$StartPath = $SolutionFolder.Substring(0, $SolutionFolder.Length - 1) #"." #"C:\inetpub\wwwroot\Kt82LatestDn45Src\"
$ExcludePattern = "\\Lib\\?"
$OutputSubfolder = "\Lib"

if (!([Security.Principal.WindowsPrincipal][Security.Principal.WindowsIdentity]::GetCurrent()).IsInRole([Security.Principal.WindowsBuiltInRole] "Administrator"))
{
    Start-Process powershell.exe "-NoProfile -ExecutionPolicy Bypass -File `"$PSCommandPath`"" -Verb RunAs
    exit
}

$assemblies = @{}
$assembliesSorted = @{}
$folder = Get-ChildItem -Path $StartPath -Filter "CMS.*.dll" -Recurse | ? { $_.FullName -notmatch $ExcludePattern } # -Exclude ($StartPath + $OutputSubfolder + "\*.dll")

if ($folder -ne $null)
{
    foreach ($file in $folder)
    {
        if (!$assemblies.ContainsKey($file.BaseName))
        {
            $assemblies.Add($file.BaseName, @{})
        }
        if (!$assemblies[$file.BaseName].ContainsKey($file.LastWriteTimeUtc))
        {
            $assemblies[$file.BaseName].Add($file.LastWriteTimeUtc, $file.FullName)
        }
        $versionsSorted = $assemblies[$file.BaseName].GetEnumerator() | sort -Property Name -Descending
        $assembliesSorted[$file.BaseName] = $versionsSorted
    }
    foreach ($assemblyName in $assembliesSorted.Keys)
    {
        $path = $assembliesSorted[$assemblyName][0].Value
        Copy-Item -Path $path -Destination ($StartPath + $OutputSubfolder) -Force
        $xmlFilePath = $path.Substring(0, $path.Length - 3) + "xml"
        if (Test-Path $xmlFilePath)
        {
            Copy-Item -Path $xmlFilePath -Destination ($StartPath + $OutputSubfolder) -Force
        }
    }
}